<app-loading *ngIf="isLoading"></app-loading>
<div class="app-card">
  <form nz-form [formGroup]="form">
    <div class="app-row" nz-row [nzGutter]="[30, 0]">
      <div nz-col nzXs="24" nzLg="12">
        <mb-select [mbDataSelects]="listApp" mbKeyLabel="appName" mbKeyValue="appId"
          [mbType]="isSubmitted && form.controls['type'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['type'].errors != null" [mbErrors]="form.controls['type'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.resource.label.attributes.type' | translate }}]"
          mbPlaceholder="--{{'system.resource.label.attributes.type' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.type' | translate}} <span class='label__required'>*</span>"
          formControlName="type"></mb-select>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <label class="input__label">{{'system.resource.label.attributes.parent' | translate}}</label>
        <app-choose-function-input [(model)]="parentId" [listFunction]="listResourceParent"></app-choose-function-input>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="code" [mbMaxLength]="50" uppercase [mbDisable]="isUpdate" (mbBlur)="codeBlur()"
          [mbType]="isSubmitted && form.controls['code'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['code'].errors != null"
          [mbErrors]="form.controls['code'].errors" [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '50' }},
           { errorName: 'code', errorDescription: 'system.validate.code' | translate },
           { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.resource.label.attributes.code' | translate }}]"
          mbPlaceholderText="--{{'system.resource.label.attributes.code' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.code' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="name" [mbMaxLength]="150"
          [mbType]="isSubmitted && form.controls['name'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['name'].errors != null"
          [mbErrors]="form.controls['name'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '150' }},
            { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.resource.label.attributes.name' | translate }}]"
          mbPlaceholderText="--{{'system.resource.label.attributes.name' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.name' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="displayName" [mbMaxLength]="150"
          [mbType]="isSubmitted && form.controls['displayName'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['displayName'].errors != null"
          [mbErrors]="form.controls['displayName'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '150' }}]"
          mbPlaceholderText="--{{'system.resource.label.attributes.displayName' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.displayName' | translate}}">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-select-check-able [mbDataSelects]="listManipulation" mbKeyLabel="name" mbKeyValue="code"
          [mbShowAction]="false" [mbShowCheckAll]="listManipulation && listManipulation.length > 0" (mbEventEmit)="emitValue($event)"
          [mbType]="isSubmitted && form.controls['scopes'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['scopes'].errors != null"
          [mbErrors]="form.controls['scopes'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.resource.label.attributes.scopes' | translate }}]"
          mbPlaceholder="--{{'system.resource.label.attributes.scopes' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.scopes' | translate}}" formControlName="scopes"></mb-select-check-able>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="iconUri" [mbMaxLength]="250"
          [mbType]="isSubmitted && form.controls['iconUri'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['iconUri'].errors != null"
          [mbErrors]="form.controls['iconUri'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '250' }}]"
          mbPlaceholderText="--{{'system.resource.label.attributes.iconUri' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.iconUri' | translate}}">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="uri" [mbMaxLength]="255" (mbBlur)="uriBlur()"
          [mbType]="isSubmitted && form.controls['uri'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['uri'].errors != null"
          [mbErrors]="form.controls['uri'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '255' }},
                          { errorName: 'url', errorDescription: 'system.validate.url' | translate},
                          { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.resource.label.attributes.uri' | translate }}]"
          mbPlaceholderText="--{{'system.resource.label.attributes.uri' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.uri' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="indexNumber" [mbMaxLength]="20" (mbBlur)="indexNumberBlur()"
          [mbType]="isSubmitted && form.controls['indexNumber'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['indexNumber'].errors != null"
          [mbErrors]="form.controls['indexNumber'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '20' }},
                          { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.resource.label.attributes.indexNumber' | translate }},
                          { errorName: 'onlyNumber', errorDescription: 'system.validate.onlyNumber' | translate }]"
          mbPlaceholderText="--{{'system.resource.label.attributes.indexNumber' | translate}}--"
          mbLabelText="{{'system.resource.label.attributes.indexNumber' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
      </div>
      <div nz-col nzXs="12" nzLg="6">
        <label class="input__label">{{'system.resource.label.attributes.isMenu' | translate}}</label>
        <div class="m-t-sm" style="width: 100%;">
          <nz-switch formControlName="isMenu" [nzCheckedChildren]="checkedTemplate"
                     [nzUnCheckedChildren]="unCheckedTemplate">
          </nz-switch>
        </div>
      </div>
      <div nz-col nzXs="12" nzLg="6" *ngIf="form.controls['isMenu'].value">
        <label class="input__label">{{'system.resource.label.attributes.isInternet' | translate}}</label>
        <div class="m-t-sm" style="width: 100%;">
          <nz-switch formControlName="isInternet" [nzCheckedChildren]="checkedTemplate"
                     [nzUnCheckedChildren]="unCheckedTemplate">
          </nz-switch>
        </div>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <label class="input__label">{{'system.resource.label.attributes.api' | translate}}</label>
        <div formArrayName="apis" *ngFor="let uri of apis.controls; let i = index;" class="item-api">
          <div class="form-group__icon" [formGroupName]="i" [class.error]="isSubmitted && uri.get('name')?.errors != null">
            <input maxlength="255" nz-input class="input" appSpecialApiInput
              formControlName="name" />
            <a (click)="deleteUri(i)"><img alt="delete.svg" src="assets/images/icon/delete.svg"> </a>
          </div>
          <div class="show-error" *ngIf="isSubmitted && uri.get('name')?.errors != null">
            <em nz-icon nzType="close-circle" nzTheme="outline"></em>
            <span class="text__message">{{'system.validate.api' | translate}}</span>
          </div>
        </div>
        <div class="form-group__icon">
          <input maxlength="255" placeholder="Nhập thông tin" nz-input appSpecialApiInput
            class="input" formControlName="api" (keyup.enter)="addUri()" />
          <a (click)="addUri()"><img alt="plus.svg" src="assets/images/icon/plus.svg"> </a>
        </div>
      </div>
    </div>
  </form>
  <div class="footer">
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="save()" mbButtonAvailableStyle="PRIMARY"
      mbButtonText="{{'common.button.save' | translate}}" mbType='SUBMIT'></mb-button>
  </div>
</div>

<ng-template #checkedTemplate><em nz-icon nzType="check"></em></ng-template>
<ng-template #unCheckedTemplate><em nz-icon nzType="close"></em></ng-template>
